<!-- Button template -->
<ng-template #contentTemplate>
  <cv-icon *ngIf="icon" [name]="icon" class="button-icon" [color]="iconColor"></cv-icon>
  <span *ngIf="label">{{ label }}</span>
  <ng-container *ngIf="labelTemplateRef">
    <ng-container *ngTemplateOutlet="labelTemplateRef; context: { $implicit: labelTemplateContext }"></ng-container>
  </ng-container>
  <cv-icon *ngIf="inProgress" class="spinner" name="spinner" color="disabled"></cv-icon>
  <span *ngIf="progressPercent" class="percent">
    {{ progressPercent | percent }}
  </span>
</ng-template>

<ng-container [ngSwitch]="mode">
  <!-- simple -->
  <ng-container *ngSwitchCase="modes.simple">
    <ng-container *ngTemplateOutlet="contentTemplate"></ng-container>
  </ng-container>

  <!-- dropdown -->
  <ng-container *ngSwitchCase="modes.dropdown">
    <div
      class="button-content"
      trigger="manual"
      #tippy="tippy"
      [tippy]="popoverTemplate"
      [hideOnClick]="true"
      variation="popover"
      [interactive]="true"
      (click)="tippy.isVisible ? tippy.hide() : tippy.show()"
    >
      <ng-container *ngTemplateOutlet="contentTemplate"></ng-container>
      <cv-icon class="cv-caret-down" name="hamburger" variation="popper"></cv-icon>
    </div>

    <ng-template #popoverTemplate let-hide>
      <ng-container *ngTemplateOutlet="dropdownTemplateRef; context: { hide: hide }"></ng-container>
    </ng-template>
  </ng-container>
</ng-container>
